﻿using System;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace NppLinefilter.Forms {
    public partial class FormAdvanced : Form {

        public FormAdvanced() {
            InitializeComponent();
        }

        private void buttonClose_Click(object sender, EventArgs e) {
            this.Close();
        }

        private void buttonPerform_Click(object sender, EventArgs e) {
            if (tabControl.SelectedTab == tabPage1) {
                // Text Search

                if (radioButtonKeep.Checked) {
                    LineFilter.KeepLinesWith(textBoxTextSearch.Text, checkBoxIgnoreCase.Checked);
                } else {
                    LineFilter.RemoveLinesWith(textBoxTextSearch.Text, checkBoxIgnoreCase.Checked);
                }
            }
            if (tabControl.SelectedTab == tabPage2) {
                // Regex Search
                if (!validateRegex(false)) {
                    return;
                }

                if (radioButtonKeep.Checked) {
                    LineFilter.KeepLinesWithRegex(textBoxRegex.Text);
                } else {
                    LineFilter.RemoveLinesWithRegex(textBoxRegex.Text);
                }
            }

            this.Close();
        }

        private string IsValidRegex() {
            try {
                Regex.IsMatch("", textBoxRegex.Text);
                return null;
            } catch (Exception e) {
                return e.Message;
            }
        }

        private void buttonValidateRegex_Click(object sender, EventArgs e) {
            validateRegex(true);
        }

        private bool validateRegex(bool showSuccessMsg) {
            string regexError = IsValidRegex();
            if (regexError == null) {
                if (showSuccessMsg) {
                    MessageBox.Show("Regex is valid.", "OK", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                return true;
            } else {
                MessageBox.Show("Regex is invalid:\r\n" + regexError, "Try again", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }
        }
    }
}
