﻿using Kbg.NppPluginNET.PluginInfrastructure;
using NppLinefilter.Forms;

namespace NppLinefilter
{
    /**
     * 
     * NPP Plugin: Line Filter
     * 
     * Author: Seelisoft
     * http://www.seelisoft.net
     * 
     * */
    
    public class Main {
        internal const string PluginName = "Line Filter";

        public static readonly string VERSION = "1.1";

        private static FormAdvanced formAdvanced;


        internal static void CommandMenuInit() {
            PluginBase.SetCommand(0, "Keep lines with selection", KeepLinesWithSelection);
            PluginBase.SetCommand(1, "Remove lines with selection", RemoveLinesWithSelection);
            PluginBase.SetCommand(2, "-", null);
            PluginBase.SetCommand(0, "Keep lines with selection (ignore case)", KeepLinesWithSelectionIgnoreCase);
            PluginBase.SetCommand(1, "Remove lines with selection (ignore case)", RemoveLinesWithSelectionIgnoreCase);
            PluginBase.SetCommand(2, "-", null);
            PluginBase.SetCommand(1, "Advanced...", Advanced);
            PluginBase.SetCommand(2, "-", null);
            PluginBase.SetCommand(1, "About...", About);
        }

        internal static void PluginCleanUp() {
        }

        public static void OnNotification(ScNotification notification) {
        }

        internal static void SetToolBarIcon() {
        }

        internal static void KeepLinesWithSelection() {
            LineFilter.KeepLinesWithSelection(false);
        }

        internal static void RemoveLinesWithSelection() {
            LineFilter.RemoveLinesWithSelection(false);
        }

        internal static void KeepLinesWithSelectionIgnoreCase() {
            LineFilter.KeepLinesWithSelection(true);
        }

        internal static void RemoveLinesWithSelectionIgnoreCase() {
            LineFilter.RemoveLinesWithSelection(true);
        }

        internal static void Advanced() {
            if (formAdvanced == null) {
                formAdvanced = new FormAdvanced();
            }

            formAdvanced.ShowDialog();
        }

        internal static void About() {
            new FormAbout().ShowDialog();
        }
    }
}